



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>C语言 稀疏矩阵 压缩 实现</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">C语言 稀疏矩阵 压缩 实现</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-03 22:30:45 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>稀疏矩阵压缩存储的C语言实现 (GCC编译)。</p>
<div>
<pre class="prettyprint linenums"> /**<br />
 * @brief C语言 稀疏矩阵 压缩 实现<br />
 * @author wid<br />
 * @date 2013-11-04<br />
 *<br />
 * @note 若代码存在 bug 或程序缺陷, 请留言反馈, 谢谢!<br />
 */

 #include &lt;stdio.h&gt;<br />
 #include &lt;stdlib.h&gt;<br />
 #include &lt;assert.h&gt;<br />
 #include &lt;string.h&gt;

 #define TRUE 1<br />
 #define FALSE 0<br />
 #define NPOS -1

 typedef int ElemType;

 typedef struct<br />
 {<br />
     int m;              ///行下标<br />
     int n;              ///列下标<br />
     ElemType elm;       ///该下标所保存的元素<br />
 }TTuple;    ///三元组结构

 typedef struct<br />
 {<br />
     TTuple *tup;        ///三元组顺序表<br />
     int row;            ///矩阵行数<br />
     int col;            ///矩阵列数<br />
     int unul;           ///非 0 元素个数<br />
 }TMatrix;   ///稀疏矩阵结构

 ///稀疏矩阵方法声明<br />
 TMatrix *CreateEmptyTMatrix( int sizeM, int sizeN );              ///创建一个大小为 sizeM x sizeN 稀疏矩阵<br />
 TMatrix *CreateTMatirxFrom2DArray( void *pArr2D, int sizeM, int sizeN );    ///从二维数组中创建稀疏矩阵<br />
 void DestroyTMatrix( TMatrix *pMat );       ///销毁稀疏矩阵<br />
 int ElemLocate( const TMatrix *const pMat, int m, int n );                  ///定位矩阵下标 m, n 在稀疏矩阵中的存储位置<br />
 void DisplayTMatrix( const TMatrix *const pMat );       ///输出稀疏矩阵<br />
 int GetTMatrixSize( const TMatrix *const pMat );        ///输出稀疏矩阵 pMat 所占用的空间大小(字节)<br />
 int AppendElem( TMatrix *const pMat, ElemType elm, int m, int n );          ///将元素 elm 添加到稀疏矩阵 m, n 位置<br />
 int DeleteElem( TMatrix *const pMat, int m, int n );    ///删除稀疏矩阵中 m, n 下标指向的元素<br />
 int TMatrixCopy( TMatrix *const pMatDest, TMatrix *const pMatSrc );         ///将稀疏矩阵 pMatSrc 复制到 pMatDest<br />
 int Value( const TMatrix *const pMat, int m, int n, ElemType *pElm );       ///从稀疏矩阵中取下标为 m, n 元素的值<br />
 void ForEach( const TMatrix *const pMat, void (*func)(ElemType *pElm) );    ///对矩阵中的每个元素依次执行 func 函数

 ///稀疏矩阵方法实现

 /**<br />
 * @brief 创建一个大小为 sizeM x sizeN 稀疏矩阵<br />
 *<br />
 * @return 返回创建的稀疏矩阵的指针<br />
 */<br />
 TMatrix *CreateEmptyTMatrix( int sizeM, int sizeN )<br />
 {<br />
     ///不接受大小为0的稀疏矩阵<br />
     assert( sizeM &gt;  &amp;&amp; sizeN &gt;  );

     TMatrix *pMat = (TMatrix *)malloc( sizeof(TMatrix) );<br />
     pMat-&gt;tup = NULL;<br />
     pMat-&gt;row = sizeM;<br />
     pMat-&gt;col = sizeN;<br />
     pMat-&gt;unul = ;

     return pMat;<br />
 }

 /**<br />
 * @brief 从二维数组中创建稀疏矩阵<br />
 *<br />
 * @param pArr2D 一个ElemType型二维数组<br />
 * @param sizeM 二维数组的行数<br />
 * @param sizeN 二维数组的列数<br />
 *<br />
 * @return 返回创建的稀疏矩阵的指针<br />
 */<br />
 TMatrix *CreateTMatirxFrom2DArray( void *pArr2D, int sizeM, int sizeN )<br />
 {<br />
     ///不接受大小为0的稀疏矩阵<br />
     assert( sizeM &gt;  &amp;&amp; sizeN &gt;  );

     TMatrix *pMat = (TMatrix *)malloc( sizeof(TMatrix) );

     ///初始化稀疏矩阵行数、列数<br />
     pMat-&gt;row = sizeM;<br />
     pMat-&gt;col = sizeN;

     ///第一趟遍历, 统计非零元素个数<br />
     int m = , n = ;<br />
     for( m = ; m &lt; sizeM; ++m )<br />
         for( n = ; n &lt; sizeN; ++n )<br />
             if( ((ElemType *)pArr2D)[sizeM * m + n] !=  )<br />
                 ++pMat-&gt;unul;

     ///申请合适长度的三元组类型的线性表<br />
     pMat-&gt;tup = (TTuple *)calloc( pMat-&gt;unul, sizeof(TTuple) );

     ///第二趟遍历, 存储二维矩阵中的非零元素<br />
     int nPos = ;<br />
     for( m = ; m &lt; sizeM; ++m )<br />
         for( n = ; n &lt; sizeN; ++n )<br />
             if( ((ElemType *)pArr2D)[sizeM * m + n] !=  )<br />
             {<br />
                 pMat-&gt;tup[nPos].m = m;<br />
                 pMat-&gt;tup[nPos].n = n;<br />
                 pMat-&gt;tup[nPos].elm = ((ElemType *)pArr2D)[sizeM * m + n];<br />
                 ++nPos;<br />
             }

     return pMat;<br />
 }

 /**<br />
 * @brief 销毁稀疏矩阵<br />
 *<br />
 * @param pMat 指向待销毁的稀疏矩阵<br />
 */<br />
 void DestroyTMatrix( TMatrix *pMat )<br />
 {<br />
     free( pMat-&gt;tup );<br />
     free( pMat );

     pMat = NULL;<br />
 }

 /**<br />
 * @brief 定位元素下标 m, n 在稀疏矩阵中出现的位置<br />
 *<br />
 * @param pMat 指向待定位元素的稀疏矩阵<br />
 * @param m 元素行下标<br />
 * @param n 元素列下标<br />
 *<br />
 * @return 若存在, 返回该下标组在稀疏矩阵中出现的位置, 否则返回 NPOS<br />
 *<br />
 * @note 元素位置由 0 计起<br />
 */<br />
 int ElemLocate( const TMatrix *const pMat, int m, int n )<br />
 {<br />
     int i = ;<br />
     for( i = ; i &lt; pMat-&gt;unul; ++i )<br />
     {<br />
         if( pMat-&gt;tup[i].m == m &amp;&amp; pMat-&gt;tup[i].n == n )<br />
             return i;<br />
     }

     return NPOS;<br />
 }

 /**&lsquo;<br />
 * @brief 输出稀疏矩阵<br />
 *<br />
 * @param pMat 指向待输出的稀疏矩阵<br />
 *<br />
 * @return void<br />
 */<br />
 void DisplayTMatrix( const TMatrix *const pMat )<br />
 {<br />
     int m = , n = , pos = ;<br />
     for( m = ; m &lt; pMat-&gt;row; ++m )<br />
     {<br />
         for( n = ; n &lt; pMat-&gt;col; ++n )<br />
         {<br />
             pos = ElemLocate( pMat, m, n );<br />
             if( pos != NPOS )<br />
                 printf( "%d ",  pMat-&gt;tup[pos].elm );<br />
             else<br />
                 printf( "%d ",  );<br />
         }<br />
         putchar( '\n' );<br />
     }<br />
 }

 /**<br />
 * @brief 获取稀疏矩阵所占用的空间大小(字节)<br />
 *<br />
 * @param pMat 指向待获取占用空间的稀疏矩阵<br />
 *<br />
 * @return 返回该矩阵所占用的空间的大小<br />
 */<br />
 int GetTMatrixSize( const TMatrix *const pMat )<br />
 {<br />
     return pMat-&gt;unul * sizeof(TTuple);<br />
 }

 /**<br />
 * @brief 将元素添加到稀疏矩阵的 m, n 位置<br />
 *<br />
 * @param pMat 指向待添加元素的稀疏矩阵<br />
 * @param elm 待添加的元素<br />
 * @param m 元素所在的行数<br />
 * @param n 元素所在的列数<br />
 *<br />
 * @return 返回添加后稀疏矩阵中非 0 元素的个数<br />
 */<br />
 int AppendElem( TMatrix *const pMat, ElemType elm, int m, int n )<br />
 {<br />
     ///断言下标合法<br />
     assert( m &gt;=  &amp;&amp; m &lt; pMat-&gt;row &amp;&amp; n &gt;=  &amp;&amp; n &lt; pMat-&gt;col );

     ///断言元素值合法(不接受元素值为0的元素)<br />
     assert( elm !=  );

     ///测试下标是否存在<br />
     int i = , pos = ;<br />
     pos = ElemLocate( pMat, m, n );<br />
     if( pos != NPOS )<br />
     {   ///下标已存在, 覆盖原值<br />
         pMat-&gt;tup[pos].elm = elm;<br />
         return pMat-&gt;unul;<br />
     }

     ///新添加<br />
     pMat-&gt;tup = (TTuple *)realloc( pMat-&gt;tup, sizeof(TTuple) * (pMat-&gt;unul + ) );<br />
     pMat-&gt;tup[pMat-&gt;unul].m = m;<br />
     pMat-&gt;tup[pMat-&gt;unul].n = n;<br />
     pMat-&gt;tup[pMat-&gt;unul].elm = elm;

     return ++pMat-&gt;unul;<br />
 }

 /**<br />
 * @brief 删除稀疏矩阵中下标 m, n 指向的元素<br />
 *<br />
 * @param pMat 指向待删除元素的稀疏矩阵<br />
 * @param m 元素行下标<br />
 * @param n 元素列下标<br />
 *<br />
 * @param 若元素存在, 则返回删除后稀疏矩阵中非 0 元素个数, 否则返回NPOS<br />
 */<br />
 int DeleteElem( TMatrix *const pMat, int m, int n )<br />
 {<br />
     ///使用断言确保下标合法<br />
     assert( m &gt;=  &amp;&amp; m &lt; pMat-&gt;row &amp;&amp; n &gt;=  &amp;&amp; n &lt; pMat-&gt;col );

     int pos = ElemLocate( pMat, m, n );

     ///该元素是否存在<br />
     if( pos == NPOS )<br />
         return NPOS;

     ///删除该位置上的元素以及记录<br />
     for( pos; pos &lt; pMat-&gt;unul - ; ++pos )<br />
     {<br />
         pMat-&gt;tup[pos].m = pMat-&gt;tup[pos+].m;<br />
         pMat-&gt;tup[pos].n = pMat-&gt;tup[pos+].n;<br />
         pMat-&gt;tup[pos].elm = pMat-&gt;tup[pos+].elm;<br />
     }

     ///缩小内容占用<br />
     pMat-&gt;tup = (TTuple *)realloc( pMat-&gt;tup, sizeof(TTuple) * (pMat-&gt;unul - ) );

     return --pMat-&gt;unul;<br />
 }

 /**<br />
 * @brief 将源稀疏矩阵复制到目标稀疏矩阵中<br />
 *<br />
 * @param pMatDest 指向目标稀疏矩阵<br />
 * @param pMatSrc 指向源稀疏矩阵<br />
 *<br />
 * @return 返回复制成功后目标稀疏矩阵中的非0元素数量<br />
 */<br />
 int TMatrixCopy( TMatrix *const pMatDest, TMatrix *const pMatSrc )<br />
 {<br />
     if( pMatDest-&gt;tup )<br />
         free( pMatDest-&gt;tup );

     ///源稀疏矩是否为空<br />
     if( pMatSrc-&gt;tup )<br />
     {   //不为空, 复制矩阵<br />
         pMatDest-&gt;tup = (TTuple *)calloc( pMatSrc-&gt;unul, sizeof(TTuple) * pMatSrc-&gt;unul );<br />
         assert( pMatDest-&gt;tup );<br />
         memcpy( pMatDest-&gt;tup, pMatSrc-&gt;tup, sizeof(TTuple) * pMatSrc-&gt;unul );<br />
     }<br />
     else pMatDest-&gt;tup = NULL;

     pMatDest-&gt;row = pMatSrc-&gt;row;<br />
     pMatDest-&gt;col = pMatSrc-&gt;col;<br />
     pMatDest-&gt;unul = pMatSrc-&gt;unul;

     return pMatDest-&gt;unul;<br />
 }

 /**<br />
 * @brief 从稀疏矩阵中获取下标为 m, n 元素的值<br />
 *<br />
 * @param pMat 指向待获取元素的稀疏矩阵<br />
 * @param m 元素所在位置的行下标<br />
 * @param n 元素所在位置的列下标<br />
 * @param pElm 接收数据元素的指针<br />
 *<br />
 * @return 返回该元素在稀疏矩阵中的位置<br />
 *<br />
 * @note 位置由 0 计起<br />
 */<br />
 int Value( const TMatrix *const pMat, int m, int n, ElemType *pElm )<br />
 {<br />
     ///使用断言确保下标合法<br />
     assert( m &gt;=  &amp;&amp; m &lt; pMat-&gt;row &amp;&amp; n &gt;=  &amp;&amp; n &lt; pMat-&gt;col );

     int pos = ElemLocate( pMat, m, n );<br />
     if( pos != NPOS )<br />
     {<br />
         *pElm = pMat-&gt;tup[pos].elm;<br />
         return pos;<br />
     }<br />
     else<br />
     {<br />
         *pElm = ;<br />
         return NPOS;<br />
     }<br />
 }

 /**<br />
 * @brief 对稀疏矩阵中的每个元素依次执行 func 函数<br />
 *<br />
 * @param pMat 指向待处理的稀疏矩阵<br />
 * @param func 回调函数<br />
 *<br />
 * @return void<br />
 */<br />
 void ForEach( const TMatrix *const pMat, void (*func)(ElemType *pElm) )<br />
 {<br />
     int m = , n = , pos = , t = ;

     for( m = ; m &lt; pMat-&gt;row; ++m )<br />
         for( n = ; n &lt; pMat-&gt;col; ++n )<br />
         {<br />
             pos = ElemLocate( pMat, m, n );

             if( pos != NPOS )<br />
                 func( &amp;pMat-&gt;tup[pos].elm );<br />
             else<br />
                 func( &amp;t );<br />
         }<br />
 }

 ///测试

 /**<br />
 * @brief ForEach的回调函数, 若元素为 0 则输出'x', 否则正常输出<br />
 */<br />
 void display( ElemType *pElm )<br />
 {<br />
     if( *pElm ==  )<br />
         putchar( 'x' );<br />
     else<br />
         printf( "%d", *pElm );<br />
 }

 int main()<br />
 {<br />
     ///稀疏因子为 0.098 的二维数组<br />
     ElemType arrMat[][] = {<br />
         {, , , , , , , , , , , , , , },<br />
         {, , , , , , , , , , , , , , },<br />
         {, , , , , , , , , , , , , , },<br />
         {, , , , , , , , , , , , , , },<br />
         {, , , , , , , , , , , , , , },<br />
         {, , , , , , , , , , , , , , },<br />
         {, , , , , , , , , , , , , , },<br />
         {, , , , , , , , , , , , , , },<br />
         {, , , , , , , , , , , , , , },<br />
         {, , , , , , , , , , , , , , },<br />
         {, , , , , , , , , , , , , , },<br />
         {, , , , , , , , , , , , , , },<br />
         {, , , , , , , , , , , , , , },<br />
         {, , , , , , , , , , , , , , },<br />
         {, , , , , , , , , , , , , , }<br />
     };

     ///测试 CreateTMatirxFrom2DArray<br />
     ///从二维数组 arrMat 中创建稀疏矩阵<br />
     TMatrix *pMat = CreateTMatirxFrom2DArray( arrMat, ,  );<br />
     printf( "稀疏矩阵占用空间大小: %d (byte)\n", GetTMatrixSize(pMat) );

     ///测试 CreateEmptyTMatrix<br />
     ///创建一个 5 x 5 大小的稀疏矩阵<br />
     TMatrix *pMat2 = CreateEmptyTMatrix( ,  );

     ///测试 TMatrixCopy<br />
     ///将 pMat 复制到 pMat2<br />
     TMatrixCopy( pMat2, pMat );

     ///测试 DisplayTMatrix<br />
     printf( "输出稀疏矩阵 pMat2:\n" );<br />
     DisplayTMatrix( pMat2 );

     ///测试 AppendElem<br />
     printf( "将 0, 0 处元素置为 1.\n" );<br />
     AppendElem( pMat2, , ,  );

     ///测试 DeleteElem<br />
     printf( "删除 0, 1 处的元素.\n" );<br />
     DeleteElem( pMat2, ,  );

     ///输出 pMat2<br />
     printf( "输出稀疏矩阵 pMat2:\n" );<br />
     DisplayTMatrix( pMat2 );

     ///测试 Value<br />
     int a = -;<br />
     Value( pMat2, , , &amp;a );<br />
     printf( "位置 10, 8 处的元素为: %d\n", a );

     ///测试 ForEach<br />
     printf( "将稀疏矩阵中值为0的元素用x代替并全部输出:\n" );<br />
     ForEach(pMat2, display );

     ///销毁稀疏矩阵<br />
     DestroyTMatrix( pMat );<br />
     DestroyTMatrix( pMat2 );

     return ;<br />
 }</pre>
</div>
<p><strong>运行测试:</strong></p>
<p><strong><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/453818/201311/04233041-c870bbe9b06945d2b8556d6be8e60ce7.png" /></strong></p>
<p>若代码存在 bug 或程序缺陷, 请留言反馈, 谢谢。 　　　&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;　　　&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;　　　&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;　　　&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;　　　&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;　　　&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;　　　&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;　　　&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;　　　&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;　　　&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;　　　&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;　　　&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;　　　&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;　　　&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;　　　&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;　　　&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;　　　&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;　　　&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;　　　&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;　　　&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;　　　&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;　　　&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;　　　&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;　　　&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;　　　&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;　　　&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;　　　&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;　　　&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;　　　&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;　　　&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;　　　&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;　　　&nbsp;&nbsp;&nbsp;&nbsp; 　　　&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;　　　</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9pjk2z9.html">Linux安装详情图解</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8owkwl9.html">MySQL关键字（保留字）列表</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdyv50q.html">读取XML文件的节点内的内容</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v2g2o8.html">Android编程&colon; 界面组成、事件监听器</a>
		</li>
						<li><a href="https://www.batexi.com/a/qded1ov9.html">Telnet连接Win7系统被拒绝的原因及解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oklwdl9.html">QTP检查点和参数化&lowbar;百度一下</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y3og5q.html">CentOS 6&period;5 安装配置VSFTP</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnz7wd8.html">&lbrack;iOS基础控件 - 6&period;5&rsqb; UITableView的数据刷新</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1313k8.html">&num;include &amp;lt&semi;boost&sol;thread&period;hpp&amp;gt&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jwmxo8.html">微信JSAPI支付&lpar;比较详细&rpar; 关于getRrandWCPayRequest&colon;fail&lowbar;invalid appid 错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp67w69.html">Spring-Cloud（三）Eureka注册中心实现高可用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25myjlq.html">python matplotlib 库学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyj7ev9.html">QQ登录用到的URL</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj40w59.html">市场不相信眼泪：AI第一股暴力裁员 惨了</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j16ox09.html">如何给Elasticsearch安装中文分词器IK</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy5vpx9.html">Spring Boot &plus; Spring Cloud 实现权限管理系统 后端篇（七）：集成 Druid 数据源</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pp5nr8.html">ApkTool反编译和重新打包</a>
		</li>
						<li><a href="https://www.batexi.com/a/qverely9.html">Github入门 - Github基本使用及Github桌面版使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1vld09.html">Google Maps 基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/8em2ekx9.html">2015309南皓芯《Java程序设计》实验一（Java开发环境的熟悉）实验报告</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/3903ym39.html">LR录制https协议报证书错误，导航已阻止</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8o6y258.html">js中object类型模拟java中的map</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwgn6r8.html">maven中添加servlet、jsp依赖</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jod44q.html">&lpar;null&rpar;&colon; Linker command failed with exit code 1 &lpar;use -v to see invocation&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdyxkzq.html">POJ 2699 The Maximum Number of Strong Kings Description</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qx34gzq.html">cell线条前后缩短</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2z6owq.html">SAP 打开账期</a>
			</li>
						<li><a href="https://www.batexi.com/a/r934r0n8.html">清空form表单下所有的input值-------------jquery</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8m54m0q.html">linux下挂载新硬盘</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7515x9.html">ADO&period;NET Entity Framework学习笔录（一）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
